clear all
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                            Michael Pokojovy                             % 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
figure(1);

set(gcf, 'PaperUnits', 'centimeters');
xSize = 24; ySize = 10;
xLeft = (21 - xSize)/2; yTop = (30 - ySize)/2;
set(gcf,'PaperPosition', [xLeft yTop xSize ySize]);
set(gcf,'Position',[0 0 xSize*50 ySize*50]);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
M = 51;
N = 51;

M2 = ceil(M/2);
N2 = ceil(N/2);

[X1, Y1] = meshgrid(linspace(-2, -1 - 0.00001, M), linspace(-1, 1, N));
[X2, Y2] = meshgrid(linspace(-1 + 0.00001, 0, M), linspace(-1, 1, N));
Z = zeros(M, N);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
subplot(1, 2, 1);
hold on;

t = title('Cartesisches Gitter im Definitionsbereich', 'interpreter', 'latex');
set(t, 'FontSize', 16);

surf(X1, Y1, Z);
surf(X2, Y2, Z);
colormap pink;

PHI = linspace(0, 2*pi, 100);
X = -1 + 0.25*cos(PHI);
Y = 0.25*sin(PHI);
plot(X, Y, 'r', 'LineWidth', 2);

grid on;
view([0 90]);

xlabel('Re z');
ylabel('Im z');
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
subplot(1, 2, 2);
hold on;

t = title('Verformtes Gitter im Bildbereich: $w = \frac{2z}{z^{2} - 1}$', 'interpreter', 'latex');
set(t, 'FontSize', 16);

Z = X1 + i*Y1;
W = 2*Z./(Z.^2 - 1);
U = real(W);
V = imag(W);
Z = zeros(M, N);
surf(U, V, Z);

Z = X2 + i*Y2;
W = 2*Z./(Z.^2 - 1);
U = real(W);
V = imag(W);
Z = zeros(M, N);
surf(U, V, Z);


Z = X + i*Y;
W = 2*Z./(Z.^2 - 1);
U = real(W);
V = imag(W);
plot(U, V, 'r', 'LineWidth', 2);

axis([-10 10 -10 10]);

colormap pink;

grid on;
view([0 90]);

xlabel('Re w');
ylabel('Im w');
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%